#!/usr/bin/env node
const cl = function(){ console.log.apply(console, arguments); };
const arg1 = process.argv[2] || false;
const arg2 = process.argv[3] || false;
const arg3 = process.argv[4] || false;

// Check is correct operation was input.
const service = require('os-service');
if(arg1 == "install"){

    // Check if service name and conf path were input.
    if(!arg2 || !arg3){
        cl('Usage: static-service install <name> <path/to/conf.yml>');
        return;
    }

    // Resolve path based on cwd.
    const name = 'static-' + arg2;
    const conf = require('path').resolve(arg3);

    // Create the new OS service.
    service.add(name, { programArgs: ["run", conf] }, err => err
        ? cl('Error: ', err.message)
        : cl('Service ' + name + ' was created.')
    );
}


else if(arg1 == "uninstall"){

    // Check if name was input.
    if(!arg2){
        cl('Usage: static-service uninstall <name>');
        return;
    }

    // Remove the OS service.
    const name = 'static-' + arg2;
    service.remove(name, err => err
        ? cl('Error: ', err.message)
        : cl('Service ' + name + ' was removed.')
    );
}

else if(arg1 == "run"){

    // Check if absolute conf path was input.
    if(!arg2){
        cl('Usage: static-service run </absolute/path/to/conf.yml>');
        return;
    }

    // Attempts and start GY2H.
    var staticServer = require('../lib/index.js');
    const socket = staticServer.start(arg2);

    // Setup service stopping.
    if(socket)
        service.run(function(){
            socket.close();
            service.stop(0);
        });
}

else
    cl('Usage: static-service [ install | run | uninstall ]');
